#File: lb_compute_signatures.py
#Author: Andres Jesse Porfirio

#This script computes all signatures from the OUTPLY folder
#The result is stored in the OUTSIGS folder
#Check for "getsig" executable in the working dir!

import os,sys,shutil

database_folder = os.path.abspath('OUT_2i/PLY/')+'/' 	#Change this path to your PLYs Dir
out_folder = os.path.abspath('OUT_2i/SIG/')+'/'		#Change this path to where you want the SIGs

if not os.path.exists(out_folder):
	os.makedirs(out_folder)

def process_file(ply_file):
	print 'Processing file:'+ply_file
	out_file = os.path.abspath(out_folder+ply_file[:-4]+'.sig')
	in_file = os.path.abspath(database_folder+ply_file)

	os.system('./getsig '+in_file+' '+out_file)

def process_database():
	for ply_file in os.listdir(database_folder):
		if not ply_file[-4:] == '.ply':
			continue
		process_file(ply_file)

if __name__ == '__main__':
	process_database()