#File: lb_organize_signatures.py
#Author: Andres Jesse Porfirio (www.andresjesse.com)
#Version:1.0

#This program organizes the input for tests:
#	SVM: separates per class
#All files will be stored in the T2i folder

import sys,os,shutil
from random import randrange

def organize_signatures():
	def clean_conf_name(fullname):
		cname = fullname.split('.')[0]
		return cname.split('_')[2]

	OUTSIGS_DIR = os.path.abspath('OUT_2i/SIG/')+'/'
	OUTDIR = 'T2i/'

	os.makedirs(OUTDIR)

	def organize_svm():
		os.makedirs(OUTDIR+'SVM/')

		#copy all to TEST folder
		for sig in os.listdir(OUTSIGS_DIR):
			dest = OUTDIR+'SVM/'+clean_conf_name(sig)+'/'

			if not os.path.exists(dest):
				os.makedirs(dest)

			shutil.copy(OUTSIGS_DIR+sig,dest)

	organize_svm()

if __name__ == '__main__':
	organize_signatures()