#File: lb_reconstruct_blender.py
#Author: Andres Jesse Porfirio (www.andresjesse.com)
#compatible with blender 2.63a

import sys,os,re

if len(sys.argv) < 3:
	print 'This program performs the 3D reconstruction using the silhuette method based on 2D images.'
	print 'The images must be stored in the "IN_2i" folder:'
	print '		DATABASE_IN/   			<-root	'
	print '			C1_1_1/						'			
	print '				out_12.jpg		<-front view'
	print '				out_15.jpg		<-side view'
	print '			C1_1_2/'
	print '				...'
	print 'Processed 3D meshs will be stored in Stanford PLY and BLEND formats at the "OUT_2i" folder:'
	print '		OUT_2i/'
	print '			BLEND/'
	print '			PLY/'
	print 'How to use this script:'
	print '				reconstruct_blender.py <IN_2i/> <OUT_2i/>'
	quit()

#common defs
def key_func(string):
	result = re.split(r'(\d+)', string)
	for i in range(1, len(result), 2):
		result[i] = int(result[i])
	return result
#-----------

folder_in = sys.argv[1]
folder_out = sys.argv[2]

if folder_in[-1] != '/':
	folder_in+='/'

if folder_out[-1] != '/':
	folder_out+='/'

#create OUT folder structure
if not os.path.exists(folder_out):
	os.makedirs(folder_out)
	os.makedirs(folder_out+'PLY/')
	os.makedirs(folder_out+'BLEND/')

list_folder_in = os.listdir(folder_in)
list_folder_in.sort(key=key_func)

#for each hand configuration in IN_2i folder perform reconstruction
for hcfg_dir in list_folder_in:
	print hcfg_dir

	#write information to be readed in blender
	params = open('params_file','w')
	params.write(folder_in+hcfg_dir+'/ ')
	params.write(folder_out)
	params.close()

	#execute blender in background to create the mesh
	cmd = 'blender --background --python bpy_reconstruct.py'
	os.system(cmd)

print 'DONE: ALL'
