#!/usr/bin/env python

#This program reads the libsvm output and generate classification logs with confusion matrix
#Author: Andres Jesse Porfirio (www.andresjesse.com)

import sys,os

if len(sys.argv) < 5:
	print 'Usage: ./lb_svm_generate_log.py <svm_predict_outfile> <input_test> <ranking_len> <log_file_output>'
	quit()

f = open(sys.argv[1])
fin = open(sys.argv[2])

fout = open(sys.argv[4],'w')

#main csv log file (../mlog.csv):
mlog = os.path.abspath(sys.argv[1])[:-len(os.path.basename(sys.argv[1]))]+'../mlog.csv'

#read ranking len
rank_len = int(sys.argv[3])

fout.write('RANK:'+str(rank_len)+'\n')

labels = [int(s) for s in f.readline().split(' ')[1:]]

hits = 0
total = 0

confusion_matrix = [ [ 0 for i in range(61) ] for j in range(61) ]

for line in f:
	probabilities = [ float(s) for s in line.split(' ')[1:] ]

	psort = probabilities[:]
	psort.sort()

	ranking = [ labels[probabilities.index(psort[-i])] for i in range(1,rank_len+1)]
	#print ranking

	correct_label = int(fin.readline().split(' ')[0])

	if correct_label in ranking:
		result = 'HIT'
		hits += 1
	else:
		result = 'MISS'
	total += 1

	fout.write(str(correct_label)+' '+str(ranking)+' '+str(result)+'\n')

	#update confusion matrix
	confusion_matrix[correct_label][ (ranking[0],correct_label)[correct_label in ranking] ]+=1

fout.write('HITS:'+str(hits/float(total)*100)+'%  '+str(hits)+' of '+str(total)+'\n')

#write this test to the main log
if not os.path.exists(mlog):
	fmlog = open(mlog,'a')
	fmlog.write('TEST_ID RANKING HIT_RATE INSTANCES_CORRECT NUMBER_OF_INSTANCES\n')
	fmlog.close()

fmlog = open(mlog,'a')
fmlog.write(os.path.abspath(sys.argv[1]).split('/')[-2]+' ')#test ID (SETx)
fmlog.write(str(rank_len)+' ')
fmlog.write(str(hits/float(total)*100)+' '+str(hits)+' '+str(total)+'\n')
fmlog.close()


f.close()
fin.close()

#write confusion matrix

def write_conf_matrix():
    for row in range(len(confusion_matrix)):
        for column in range(len(confusion_matrix[row])):
            fout.write( str(confusion_matrix[row][column])+' ')
        fout.write('\n')

fout.write('CONFUSION MATRIX:\n')
write_conf_matrix()

fout.close()